# coding: latin-1
"""
Diese Datei ist Teil der Stifte-und-Muse-Portierung fr Python,
entstanden im Rahmen der Diplomarbeit von Ingo Linkweiler,
verfentlicht unter der Creative Commons Lizenz by-nc-sa,
naehere Informationen dazu unter
http://creativecommons.org/licenses/by-nc-sa/3.0/de/.

 Erste Version: Mrz 2003
 Autor: i.linkweiler@gmx.de
   
 Letzte nderung:
   16.01.2009 von Matthias Heming (matthias@familie-heming.de)
     Verschieben des Eingangskommentar in Server- und Client-Klasse
"""

from socket import *
from threading import *
import time
import sys

SOCKET_NR=9051

class Server:
  """
  Server und Client sind zwei einfache Klassen zur Kommunikation ber Sockets.
  Der Client versendet per sendmsg Telegramme.
  Der Server ruft daraufhin eine callback-Funktion auf, und liefert das Ergebnis der Funktion
  an den Client zurck.
  """
  def __init__(self,callback):
      """
      Starte den Kommunikationsserver-Prozess. Callback ist eine Funktion,
      die beim Empfang von Daten aufgerufen wird, siehe Beispiel.
      """
      self.srvactive=0
      self.msgs=[]
      self.startserver()
      self.callback=callback
      print "Server-Objekt erstellt."

  def serverthread(self):
      "Starte Verbindung und warte auf Daten"    
      
      self.srvactive=1  #Warte auf Verbindung
      self.raus=0
      
      #print "--- SERVER gestartet ---"
      s=socket(AF_INET,SOCK_STREAM)
      s.setsockopt(SOL_SOCKET,SO_KEEPALIVE,1)
      s.bind(("",SOCKET_NR))
      
      print "Server wartet auf Verbindung...",
      s.listen(5)
      (conn,addr)=s.accept()
      s.close()
      print "Server hat Verbindung aufgebaut."
      
      self.srvactive=2   #Verbunden....
      #print "OK"
      self.conn=conn
      self.conn.setblocking(1)
      
      ein=""
      timeout=0
      
      while not self.raus:
        try:
          #rec = conn.recv(1024)
          rec = conn.recv(1)
          if rec==chr(27): self.raus=1
          
          if len(rec)<1:
            print "Client hat Verbindung geschlossen."
            self.raus=1
          else:
            ein = ein + rec
            timeout=0
        except error, nummer:
          if nummer[0]<>10035:
            print "Abbruch der Verbindung, Fehler#",nummer
            self.callback('"ende"')
            self.raus=1
        
        # Wenn Zeilenende erkannt, Eingabe in Nachrichtenpuffer msgs schreiben.
        while ein.count("\n")>0:
          pos = ein.index("\n")
          befehl = ein[:pos]
          ein = ein [pos+1:]
          #print "Server received",befehl      
          r=self.callback(befehl)
          self.conn.send(r+"\n")
          self.msgs.append(befehl)   
        
        #timeout=timeout+1
        #if timeout>1000:
        #time.sleep(0.002)
        #print "S*", 
      
      print "Server Thread beendet ---"
      self.srvactive=3
  
  def startserver(self):
      "intern: starte den Server-Thread"
      errors=0
      while self.srvactive>0:
        print "Server wurde doppelt gestartet... Warte 1 sec fr Neuversuch..."
        time.sleep(1)
        errors=errors+1
        if errors>5:
          print "FEHLER: Server doppelt gestartet."
          raise "Server doppelt"
        
      print "erzeuge neuen Server..."
      sst = Thread(target = self.serverthread)   # dies...
      sst.start()                        # ...ist schon alles!

  def kill(self):
      "Wecke den Server aus Listen() und beende den Server"
      if self.srvactive==1: # in Listen-Schleife
        c=socket(AF_INET,SOCK_STREAM)
        c.setsockopt(SOL_SOCKET,SO_KEEPALIVE,1)
        c.connect(("localhost",SOCKET_NR))
        c.setblocking(0)
        c.close()
      else: print "Es luft noch ein Client. Kann jetzt nicht beenden."
  
class Client:
  """
  Server und Client sind zwei einfache Klassen zur Kommunikation ber Sockets.
  Der Client versendet per sendmsg Telegramme.
  Der Server ruft daraufhin eine callback-Funktion auf, und liefert das Ergebnis der Funktion
  an den Client zurck.
  """
  def __init__(self):
      "Erzeuge neuen Client"
      self.msgs=[]

      #print "Erzeuge Socket...",
      c=socket(AF_INET,SOCK_STREAM)
      c.setsockopt(SOL_SOCKET,SO_KEEPALIVE,1)
      #print "OK"
      #print "Connect...",

      c.connect(("localhost",SOCKET_NR))
      self.conn=c
      self.conn.setblocking(1)
  
  def sendmsg(self,msg):
      "Sende eine Nachricht"
      #print "Client sendet",msg
      self.conn.send(msg+"\n")
      r=""
      while 1:
        c=self.conn.recv(1)
        if c=="\n":
          #print "Client bekam antwort",r
          return r
          break
        else:
          r=r+c
           
  def close(self):
      "Beende den Client"
      self.conn.close()

def testcallback(txt):
  print "Callback",txt
  return "ok."

# call the "main" function if running this script
if __name__ == '__main__':
    s=Server(testcallback)
    c=Client()
    print c.sendmsg("Hallo;")
    print c.sendmsg("test")
    print c.sendmsg("Hallo2;")
    c.close()
    
